diff -rNci gcc-2.7.2/combine.c gcc-2.7.2p/combine.c
*** gcc-2.7.2/combine.c	Sun Nov 26 19:32:07 1995
--- gcc-2.7.2p/combine.c	Tue Jan 23 09:53:17 1996
***************
*** 97,102 ****
--- 97,106 ----
  #include "recog.h"
  #include "real.h"
  
+ /* intel1 */
+ static int in_recombine=0;
+ extern FILE *combine_dump_file;
+ 
  /* It is not safe to use ordinary gen_lowpart in combine.
     Use gen_lowpart_for_combine instead.  See comments there.  */
  #define gen_lowpart dont_use_gen_lowpart_you_dummy
***************
*** 386,391 ****
--- 390,418 ----
  
  static int n_occurrences;
  
+ /* intel2 - begin */
+ 
+ #define INSN_SETS_REGNO(INSN, REGNO) dead_or_set_regno_p (INSN, REGNO)
+ #define INSN_USES_REGNO(INSN, REGNO) refers_to_regno_p (REGNO, \
+ 							REGNO + 1, \
+                                                         PATTERN (INSN), \
+                                                         0)
+ 
+ /* if this flag is set do not recombine unscheded riscified insns, which their
+  * original insn's destination was a memory.
+  */
+ extern int flag_risc_mem_dest;
+ 
+ /* if this flag is set try to riscify stores of CONST_INTs */
+ extern int flag_risc_const;
+ 
+ void update_free_regs (rtx);
+ static void update_regno_holds_mem (rtx insn, rtx pat);
+ static int remove_redundant_store (rtx mem, int block);
+ static void update_entries (rtx reg);
+ 
+ /* intel2 - end */
+ 
  static void init_reg_last_arrays	PROTO(());
  static void setup_incoming_promotions   PROTO(());
  static void set_nonzero_bits_and_sign_copies  PROTO((rtx, rtx));
***************
*** 445,450 ****
--- 472,486 ----
  static void distribute_notes	PROTO((rtx, rtx, rtx, rtx, rtx, rtx));
  static void distribute_links	PROTO((rtx));
  static void mark_used_regs_combine PROTO((rtx));
+ static int try_forwards_replace PROTO((rtx, rtx, rtx, FILE *));
+ /* intel2 */
+ #if 0
+ static void dump_free_registers ();
+ #endif
+ int find_free_reg();
+ static int find_regno_holds_mem (rtx, enum machine_mode);
+ /* intel1 */
+ static int try_backwards_replace ();
  
  /* Main entry point for combiner.  F is the first insn of the function.
     NREGS is the first unused pseudo-reg number.  */
***************
*** 881,886 ****
--- 917,925 ----
  
    /* Don't eliminate a store in the stack pointer.  */
    if (dest == stack_pointer_rtx
+       /* intel1 
+       || (in_recombine && GET_CODE (dest) == REG
+           && reg_used_between_p (dest, insn, i3)) */
        /* If we couldn't eliminate a field assignment, we can't combine.  */
        || GET_CODE (dest) == ZERO_EXTRACT || GET_CODE (dest) == STRICT_LOW_PART
        /* Don't combine with an insn that sets a register to itself if it has
***************
*** 1059,1064 ****
--- 1098,1105 ----
     On machines where SMALL_REGISTER_CLASSES is defined, we don't combine
     if the destination of a SET is a hard register that isn't a user
     variable.
+    intel2 - This is true unless we are in recombine (indicated by
+    in_recombine)
  
     Before doing the above check, we first try to expand a field assignment
     into a set of logical operations.
***************
*** 1128,1139 ****
--- 1169,1194 ----
  	     CALL operation.  */
  	  || (GET_CODE (inner_dest) == REG
  	      && REGNO (inner_dest) < FIRST_PSEUDO_REGISTER
+ 	      /* intel2 - begin */
+ 	      /* if we are in the recombine phase, we should not eliminate the
+ 	       * possibility for combine if the destination is a hard register.
+ 	       */
+ 	      && (!in_recombine)
+ 	      /* intel2 - end */
  	      && (! HARD_REGNO_MODE_OK (REGNO (inner_dest),
  					GET_MODE (inner_dest))
  #ifdef SMALL_REGISTER_CLASSES
  		 || (GET_CODE (src) != CALL && ! REG_USERVAR_P (inner_dest))
  #endif
  		  ))
+ 
+       /* intel2 - begin */
+       /* if we want to leave mem-dest riscified instructions untouched... */
+       || (in_recombine
+ 		&& flag_risc_mem_dest
+ 		&& GET_CODE (inner_dest) == MEM)
+       /* intel2 - end */
+ 
  	  || (i1_not_in_src && reg_overlap_mentioned_p (i1dest, src)))
  	return 0;
  
***************
*** 1389,1394 ****
--- 1444,1468 ----
        return 0;
      }
  
+   /* intel1 */
+   if (in_recombine)
+     {
+       if (i1 && GET_CODE (PATTERN (i1)) == SET 
+           && GET_CODE (SET_DEST (PATTERN (i1))) == REG
+           && reg_used_between_p (SET_DEST (PATTERN (i1)), i1, i2))
+         {
+           undo_all ();
+           return 0;
+         }
+       if (i2 && GET_CODE (PATTERN (i2)) == SET 
+           && GET_CODE (SET_DEST (PATTERN (i2))) == REG
+           && reg_used_between_p (SET_DEST (PATTERN (i2)), i2, i3))
+         {
+           undo_all ();
+           return 0;
+         }
+     }
+ 
    /* Record whether I2DEST is used in I2SRC and similarly for the other
       cases.  Knowing this will help in register status updating below.  */
    i2dest_in_i2src = reg_overlap_mentioned_p (i2dest, i2src);
***************
*** 2021,2026 ****
--- 2095,2142 ----
  	  = recog_for_combine (&newpat, i3, &new_i3_notes, &i3_scratches);
      }
  
+    /* intel1 , maybe we can rearrange memory so it is recognized */
+ #ifdef REWRITE_ADDRESS
+    if (insn_code_number==-1 && GET_CODE(newpat)==SET && i1==NULL)
+      {
+        rtx copy_of_newpat,try_to_make_good(); /* see loop.c */
+        rtx new_src_copy,new_dest_copy;
+        int dummy;
+        char * storage;
+        storage = (char *) oballoc(0);
+        copy_of_newpat = copy_rtx (newpat);
+        new_src_copy = SET_SRC (copy_of_newpat);
+        try_to_make_good (SET_SRC (copy_of_newpat));
+        try_to_make_good (SET_DEST (copy_of_newpat));
+        if (recog (copy_of_newpat, i3, &dummy) != -1)
+          {
+            int scrat;
+            newpat = copy_of_newpat;
+            insn_code_number = recog_for_combine (&newpat, i3, &new_i3_notes, &scrat);
+          }
+        else if (GET_CODE (new_src_copy) != MEM)
+          {
+            new_src_copy = gen_rtx (MEM, GET_MODE( new_src_copy), new_src_copy);
+            try_to_make_good (new_src_copy);
+            SET_SRC (copy_of_newpat) = XEXP (new_src_copy,0);
+            if (recog (copy_of_newpat,i3,&dummy) != -1)
+              {
+                int scrat;
+                newpat = copy_of_newpat;
+                insn_code_number = recog_for_combine (&newpat,i3,&new_i3_notes,&scrat);
+              }
+            else
+              {
+                obfree (storage);
+              }
+          }
+        else
+          {
+            obfree (storage);
+          }
+      }
+ #endif /* REWRITE_ADDRESS */
+ 
    /* If it still isn't recognized, fail and change things back the way they
       were.  */
    if ((insn_code_number < 0
***************
*** 2031,2036 ****
--- 2147,2176 ----
        return 0;
      }
  
+  /* intel2 - begin */
+ #ifdef REGISTER_CONSTRAINTS
+    /* check if the combined insn is a legal one */
+    if (in_recombine)
+      {
+        register rtx temp_pat = PATTERN (i3);
+        register int temp_code_number = INSN_CODE (i3);
+ 
+        /* change it only for the following check */
+        PATTERN (i3) = newpat;
+        INSN_CODE (i3) = insn_code_number;
+        insn_extract (i3);
+        /* restore the data */
+        PATTERN (i3) = temp_pat;
+        INSN_CODE (i3) = temp_code_number;
+        if (! constrain_operands (insn_code_number, 1))
+          {
+            undo_all();
+            return 0;
+          }
+      }
+ #endif
+  /* intel2 - end */
+ 
    /* If we had to change another insn, make sure it is valid also.  */
    if (undobuf.other_insn)
      {
***************
*** 4248,4253 ****
--- 4388,4401 ----
        int other_changed = 0;
        enum machine_mode compare_mode = GET_MODE (dest);
  
+     /* intel1 */
+ #ifdef HAVE_cc0
+     if(SET_DEST (x) == cc0_rtx && compare_mode==VOIDmode)
+       {
+         compare_mode = GET_MODE (SET_SRC (x));
+       }
+ #endif
+ 
        if (GET_CODE (src) == COMPARE)
  	op0 = XEXP (src, 0), op1 = XEXP (src, 1);
        else
***************
*** 9912,9918 ****
    for (link = REG_NOTES (insn); link; link = XEXP (link, 1))
      {
        if (REG_NOTE_KIND (link) == REG_DEAD
! 	  && GET_CODE (XEXP (link, 0)) == REG)
  	{
  	  int regno = REGNO (XEXP (link, 0));
  	  int endregno
--- 10060,10072 ----
    for (link = REG_NOTES (insn); link; link = XEXP (link, 1))
      {
        if (REG_NOTE_KIND (link) == REG_DEAD
!           /* intel2 - begin */
!           /* if in_recombine we might encounter a REG_DEAD note of memory!
!            */
!           && (! in_recombine
!               || GET_CODE (XEXP (link, 0)) == REG)
!           /* intel2 - end */
!       	 )
  	{
  	  int regno = REGNO (XEXP (link, 0));
  	  int endregno
***************
*** 10755,10806 ****
  
  	  if (place == 0)
  	    {
! 	      for (tem = prev_nonnote_insn (i3);
  		   place == 0 && tem
  		   && (GET_CODE (tem) == INSN || GET_CODE (tem) == CALL_INSN);
  		   tem = prev_nonnote_insn (tem))
! 		{
! 		  /* If the register is being set at TEM, see if that is all
! 		     TEM is doing.  If so, delete TEM.  Otherwise, make this
! 		     into a REG_UNUSED note instead.  */
! 		  if (reg_set_p (XEXP (note, 0), PATTERN (tem)))
! 		    {
! 		      rtx set = single_set (tem);
  
! 		      /* Verify that it was the set, and not a clobber that
! 			 modified the register.  */
  
! 		      if (set != 0 && ! side_effects_p (SET_SRC (set))
! 			  && (rtx_equal_p (XEXP (note, 0), SET_DEST (set))
! 			      || (GET_CODE (SET_DEST (set)) == SUBREG
! 				  && rtx_equal_p (XEXP (note, 0),
! 						  XEXP (SET_DEST (set), 0)))))
! 			{
! 			  /* Move the notes and links of TEM elsewhere.
! 			     This might delete other dead insns recursively. 
! 			     First set the pattern to something that won't use
! 			     any register.  */
! 
! 			  PATTERN (tem) = pc_rtx;
! 
! 			  distribute_notes (REG_NOTES (tem), tem, tem,
! 					    NULL_RTX, NULL_RTX, NULL_RTX);
! 			  distribute_links (LOG_LINKS (tem));
! 
! 			  PUT_CODE (tem, NOTE);
! 			  NOTE_LINE_NUMBER (tem) = NOTE_INSN_DELETED;
! 			  NOTE_SOURCE_FILE (tem) = 0;
! 			}
! 		      else
! 			{
! 			  PUT_REG_NOTE_KIND (note, REG_UNUSED);
! 			  
! 			  /*  If there isn't already a REG_UNUSED note, put one
! 			      here.  */
! 			  if (! find_regno_note (tem, REG_UNUSED,
! 						 REGNO (XEXP (note, 0))))
! 			    place = tem;
! 			  break;
  		      }
  		  }
  		else if (reg_referenced_p (XEXP (note, 0), PATTERN (tem))
--- 10909,10973 ----
  
  	  if (place == 0)
  	    {
! 	    for (tem = prev_nonnote_insn (i3);
  		   place == 0 && tem
  		   && (GET_CODE (tem) == INSN || GET_CODE (tem) == CALL_INSN);
  		   tem = prev_nonnote_insn (tem))
! 	      {
! 		/* If the register is being set at TEM, see if that is all
! 		   TEM is doing.  If so, delete TEM.  Otherwise, make this
! 		   into a REG_UNUSED note instead.  */
! 		if (reg_set_p (XEXP (note, 0), PATTERN (tem)))
! 		  {
! 		    rtx set = single_set (tem);
  
! 		    /* Verify that it was the set, and not a clobber that
! 		       modified the register.  */
  
! 		    if (set != 0 && ! side_effects_p (SET_SRC (set))
!  			&& (rtx_equal_p (XEXP (note, 0), SET_DEST (set))
!  			    || (GET_CODE (SET_DEST (set)) == SUBREG
!  				&& rtx_equal_p (XEXP (note, 0),
!  						XEXP (SET_DEST (set), 0)))))
! 		      {
! 			/* Move the notes and links of TEM elsewhere.
! 			   This might delete other dead insns recursively. 
! 			   First set the pattern to something that won't use
! 			   any register.  */
! 
! 			PATTERN (tem) = pc_rtx;
! 
! 			distribute_notes (REG_NOTES (tem), tem, tem,
! 					  NULL_RTX, NULL_RTX, NULL_RTX);
! 			distribute_links (LOG_LINKS (tem));
! 
! 			PUT_CODE (tem, NOTE);
! 			NOTE_LINE_NUMBER (tem) = NOTE_INSN_DELETED;
! 			NOTE_SOURCE_FILE (tem) = 0;
! 		      }
! 		    else
! 		      {
!               /* intel1 making this into reg_unused causes
!                  bug in scheduler since sched will see this
!                  as a reg_dead */
! #if 0
! 			PUT_REG_NOTE_KIND (note, REG_UNUSED);
! #endif
! 
! #if 0
! 			/*  If there isn't already a REG_UNUSED note, put one
! 			    here.  */
! 			if (! find_regno_note (tem, REG_UNUSED,
! 					       REGNO (XEXP (note, 0))))
! 			  place = tem;
! #else
!           /*  If there isn't already a REG_DEAD note, put one
!               here.  */
!           if (! find_regno_note (tem, REG_DEAD,
!                          REGNO (XEXP (note, 0))))
!             place = tem;
! #endif
! 			break;
  		      }
  		  }
  		else if (reg_referenced_p (XEXP (note, 0), PATTERN (tem))
***************
*** 10826,10832 ****
  		      }
  		    break;
  		  }
! 		}
  	      
  	      /* If we haven't found an insn for the death note and it
  		 is still a REG_DEAD note, but we have hit a CODE_LABEL,
--- 10993,10999 ----
  		      }
  		    break;
  		  }
! 	      }
  	      
  	      /* If we haven't found an insn for the death note and it
  		 is still a REG_DEAD note, but we have hit a CODE_LABEL,
